// sample code to produce correct fermionic signs (Joerg 2012-08)
// permutation per creation/annihilation: ciu.cid.aiu.aid ???
// from:  uX.   dX.  3X.  dXu        3Xu   3Xd ????
// to:  +p.Xu +p.Xd +.X3 -uXd      -puX3 -pdX3 ??? ToDo
//  p=Parity(X)
#include <stdlib.h>
#include <stdio.h>
typedef int tbase;

int main(){
 // minimum demonstration is 4 sites but hexcode is better readable
 //   for 6 sites = 3 hexdiggits
 int nn=6;  // 6 sites (exchange 0+4, sign depends from parity of site 1+2+3)
 int sym_i[6]={4,1,2,3,0,5}; // exchange sites 0 and 4
 int i1, i2, i3, s, ss, m1, m2, ib1;
  // Sample configs:  0=empty 1=up 2=down 3=up+down f=33(two sites for parity)
 int cfgs[8]={0x0f0,0x0f1,0x0f3,0x1f1,0x1f2,0x1f3,0x3f1,0x3f3};
 // taken and modified from hilbert.c get_symconfig()
 for (i1=0;i1<8;i1++) {
   ib1=cfgs[i1];
   i3=i2=0l; s=0;                      /* remove from NN-1 to 0 */
   for(m1=2*nn-1;m1>=0;m1--)if((ib1>>m1)&1){ /* m1 = old index */
     m2 = sym_i[m1/2]*2  | (m1&1);       /* m2 = new index */
     i2 |= ((tbase)1) << m2;                 /* move spin to site m2 */
     // if (m2>0) s^=(int)(1&(i3>>(m2-1)));     /* number of spins jumped over */
     s^=(int)(1&(i3>>m2));     /* number of spins jumped over */
     i3 ^= (~(tbase)0)<<m2;              /* derived fermionic sign, 64bit?? */
   }
   printf(" hexcfg %03x to %c %03x   ", ib1, ((s)?'-':'+'), i2);
   ib1=cfgs[i1] ^ 0x080;
   i3=i2=0l; s=0;                      /* remove from NN-1 to 0 */
   for(m1=2*nn-1;m1>=0;m1--)if((ib1>>m1)&1){ /* m1 = old index */
     m2 = sym_i[m1/2]*2  | (m1&1);       /* m2 = new index */
     i2 |= ((tbase)1) << m2;                 /* move spin to site m2 */
     // if (m2>0) s^=(int)(1&(i3>>(m2-1)));     /* number of spins jumped over */
     s^=(int)(1&(i3>>m2));     /* number of spins jumped over */
     i3 ^= (~(tbase)0)<<m2;              /* derived fermionic sign, 64bit?? */
   }
   printf(" hexcfg %03x to %c %03x\n", ib1, ((s)?'-':'+'), i2);
  } /* i1 loop 0..7 */
  {
   ib1=0x173;
   i3=i2=0l; s=0;                      /* remove from NN-1 to 0 */
   for(m1=2*nn-1;m1>=0;m1--)if((ib1>>m1)&1){ /* m1 = old index */
     m2 = sym_i[m1/2]*2  | (m1&1);       /* m2 = new index */
     i2 |= ((tbase)1) << m2;                 /* move spin to site m2 */
     // if (m2>0) s^=(int)(1&(i3>>(m2-1)));     /* number of spins jumped over */
     s^=(int)(1&(i3>>m2));     /* number of spins jumped over */
     i3 ^= (~(tbase)0)<<m2;              /* derived fermionic sign, 64bit?? */
     printf(" hexcfg %03x to sgn=%c %03x\n", ib1, ((s)?'-':'+'), i2);
   }
  }
  return 0;
}
